# Orders (DOMS)

DOMS endpoints to create, retrieve, update, and manage customer orders.

## GET /api/orders

> List orders

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"DOMS endpoints to create, retrieve, update, and manage customer orders.","name":"Orders (DOMS)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StrippedOrders":{"properties":{"orders":{"items":{"$ref":"#/components/schemas/StrippedOrder"},"type":"array"},"total":{"description":"Total number of found entities for this query","type":"integer"}},"type":"object","title":"StrippedOrders","description":"StrippedOrders"},"StrippedOrder":{"allOf":[{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"id":{"description":"The id of this order. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"orderDate":{"description":"The date this order was created at the supplying system.","format":"date-time","type":"string"},"orderLineItems":{"items":{"properties":{"quantity":{"description":"quantity of the specific article that has been ordered","format":"int64","minimum":1,"type":"integer"},"title":{"type":"string"}},"required":["quantity","title"],"type":"object"},"type":"array"},"processRef":{"type":"string"},"status":{"$ref":"#/components/schemas/OrderStatus"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"type":"array"}},"required":["id","status","orderDate"],"type":"object"}],"title":"StrippedOrder","description":"StrippedOrder"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"OrderStatus":{"description":"The state of the order. Initially it is OPEN.","enum":["OPEN","CANCELLED","PROMISED","LOCKED","OBSOLETE"],"type":"string","title":"OrderStatus"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/orders":{"get":{"description":"","operationId":"getAllOrders","parameters":[{"description":"all entities after given Id","in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"description":"number of entities to show","in":"query","name":"size","required":false,"schema":{"default":25,"type":"integer"}},{"description":"filter orders by tenantOrderId","in":"query","name":"tenantOrderId","required":false,"schema":{"type":"string"}},{"description":"filter orders by consumerId","in":"query","name":"consumerId","required":false,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StrippedOrders"}}},"description":"Orders are found."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"List orders","tags":["Orders (DOMS)"]}}}}
```

## POST /api/orders

> Create order

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"DOMS endpoints to create, retrieve, update, and manage customer orders.","name":"Orders (DOMS)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"OrderForCreation":{"additionalProperties":false,"properties":{"consumer":{"$ref":"#/components/schemas/OrderForCreationConsumer"},"customAttributes":{"description":"Attributes that can be added to the order. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"customServices":{"items":{"$ref":"#/components/schemas/CustomServiceReferenceForCreation"},"minItems":1,"type":"array"},"deliveryPreferences":{"$ref":"#/components/schemas/DeliveryPreferences"},"orderDate":{"description":"The date this order was created at the supplying system.","format":"date-time","type":"string"},"orderLineItems":{"items":{"$ref":"#/components/schemas/OrderLineItemForCreation"},"type":"array"},"paymentInfo":{"$ref":"#/components/schemas/OrderPaymentInfoForCreation"},"promisesOptions":{"$ref":"#/components/schemas/OrderPromisesOptions"},"source":{"description":"Defines the source of this order. This field is not required, if the order is created based on an external system.","oneOf":[{"$ref":"#/components/schemas/SourceRef"},{"$ref":"#/components/schemas/TenantSourceId"}],"type":"object"},"status":{"$ref":"#/components/schemas/OrderStatus"},"statusReasons":{"items":{"$ref":"#/components/schemas/OrderStatusReason"},"type":"array"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"maxItems":100,"minItems":1,"type":"array"},"tenantOrderId":{"description":"Field can be used as a reference number in foreign systems, for example as a reference to the source system's identifier for this order.","type":"string"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"minItems":1,"type":"array"}},"required":["orderDate","orderLineItems","consumer"],"type":"object","xml":{"name":"Order"},"title":"OrderForCreation","description":"OrderForCreation"},"OrderForCreationConsumer":{"properties":{"addresses":{"items":{"$ref":"#/components/schemas/ConsumerAddress"},"type":"array"},"consumerId":{"description":"The id of the consumer.","type":"string"},"customAttributes":{"description":"Attributes that can be added to the consumer. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"email":{"deprecated":true,"description":"@deprecated The email address of the consumer. Use email in addresses array\n","format":"email","type":"string"},"facilityRef":{"description":"ID of the facility, if the recipient is a facility.","type":"string"},"tenantFacilityId":{"description":"tenantFacilityId of the facility, if the recipient is a facility","type":"string"}},"type":"object","title":"OrderForCreationConsumer","description":"OrderForCreationConsumer"},"ConsumerAddress":{"allOf":[{"$ref":"#/components/schemas/Address"}],"properties":{"addressType":{"$ref":"#/components/schemas/AddressType"},"companyName":{"type":"string"},"coordinates":{"$ref":"#/components/schemas/Coordinates"},"email":{"format":"email","minLength":1,"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"personalTitle":{"type":"string"},"salutation":{"type":"string"}},"type":"object","title":"ConsumerAddress","description":"ConsumerAddress"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"AddressType":{"description":"Type of this address, used e.g. for communication with the carrier. Use POSTAL_ADDRESS for the address where the order should be shipped to, INVOICE_ADDRESS for the address where the invoice is sent to and PARCEL_LOCKER if a parcel locker is used for this order.","enum":["POSTAL_ADDRESS","PARCEL_LOCKER","INVOICE_ADDRESS"],"type":"string","title":"AddressType"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"CustomServiceReferenceForCreation":{"additionalProperties":false,"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItemForCreation"},"type":"array"}},"required":["customServiceDefinition","articleItems","customServiceItems"],"type":"object","title":"CustomServiceReferenceForCreation","description":"CustomServiceReferenceForCreation"},"ArticleItem":{"additionalProperties":false,"properties":{"quantity":{"minimum":1,"type":"number"},"tenantArticleRef":{"type":"string"}},"required":["quantity","tenantArticleRef"],"type":"object","title":"ArticleItem","description":"ArticleItem"},"CustomServiceDefinition":{"properties":{"additionalInformation":{"description":"Additional information necessary to fulfil the custom service","items":{"properties":{"additionalInformationRef":{"description":"A reference to the specific additional information of the custom service","type":"string"},"tenantAdditionalInformationId":{"description":"The id of the tenant specific additional information","type":"string"},"value":{"anyOf":[{"type":"string"},{"type":"integer"},{"type":"number"},{"type":"boolean"}],"description":"The value of the additional information"}},"required":["additionalInformationRef"],"type":"object"},"type":"array"},"customAttributes":{"description":"Attributes that can be added to the consumer. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"customServiceRef":{"description":"A reference to the custom service to be applied to the orderline items","type":"string"},"isBundled":{"description":"if true all articles below this service are intrpreted as a bundle","type":"boolean"},"tenantCustomServiceId":{"description":"The id of the tenant specific custom service","type":"string"}},"type":"object","title":"CustomServiceDefinition","description":"CustomServiceDefinition"},"CustomServiceItemForCreation":{"additionalProperties":false,"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItemForCreation"},"type":"array"}},"required":["customServiceItems","articleItems","customServiceDefinition"],"type":"object","title":"CustomServiceItemForCreation","description":"CustomServiceItemForCreation"},"DeliveryPreferences":{"additionalProperties":false,"properties":{"collect":{"items":{"$ref":"#/components/schemas/CollectDelivery"},"maxItems":1,"type":"array"},"reservationPreferences":{"$ref":"#/components/schemas/DeliveryReservationPreferences"},"shipping":{"$ref":"#/components/schemas/DeliveryPreferencesShipping"},"sourcingOptionRefs":{"description":"Id of the SourcingOptions","items":{"description":"Reference of a SourcingOptions","type":"string"},"type":"array"},"supplyingFacilities":{"description":"@deprecated Use supplyingFacilities under collect","items":{"description":"Reference of a Facility","type":"string"},"type":"array"},"targetTime":{"description":"At which time the result is expected.","format":"date-time","type":"string"}},"type":"object","title":"DeliveryPreferences","description":"DeliveryPreferences"},"CollectDelivery":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"facilityRef":{"description":"Reference to the facility where the consumer expects to collect the items","type":"string"},"paid":{"default":false,"description":"Indicates if the order is already paid.","type":"boolean"},"provisioningTime":{"description":"The point in time by which the order is supposed to be provisioned.","format":"date-time","type":"string"},"supplyingFacilities":{"deprecated":true,"description":"@deprecated Use supplyingFacilitiesConfigurations","items":{"description":"Reference of a Facility.","type":"string"},"type":"array"},"supplyingFacilitiesConfigurations":{"description":"References of facility that could supply contents of the order to another facility with specific configuration of its usage","items":{"$ref":"#/components/schemas/SupplyingFacilityConfiguration"},"type":"array"},"tenantFacilityId":{"description":"Reference to the facility where the consumer expects to collect the items.","type":"string"}},"type":"object","title":"CollectDelivery","description":"CollectDelivery"},"SupplyingFacilityConfiguration":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"deliveryEvents":{"items":{"$ref":"#/components/schemas/DeliveryEvent"},"type":"array"},"facilityRef":{"description":"ID of the facility.","type":"string"},"tenantFacilityId":{"description":"Reference to the facility.","type":"string"}},"required":["deliveryEvents"],"title":"SupplyingFacilityConfiguration","description":"SupplyingFacilityConfiguration"},"DeliveryEvent":{"properties":{"deliveryTarget":{"$ref":"#/components/schemas/DeliveryTarget"},"deliveryTrigger":{"enum":["DEFAULT"],"type":"string"}},"required":["deliveryTarget","deliveryTrigger"],"title":"DeliveryEvent","description":"DeliveryEvent"},"DeliveryTarget":{"description":"The destination for a delivery","enum":["SHIP_TO_STORE","SHIP_TO_CUSTOMER"],"type":"string","title":"DeliveryTarget"},"DeliveryReservationPreferences":{"properties":{"mode":{"$ref":"#/components/schemas/DeliveryReservationMode"},"reservationTime":{"format":"date-time","type":"string"}},"required":["mode"],"type":"object","title":"DeliveryReservationPreferences","description":"DeliveryReservationPreferences"},"DeliveryReservationMode":{"enum":["SCHEDULED","ASAP","ALAP"],"title":"DeliveryReservationMode","description":"DeliveryReservationMode"},"DeliveryPreferencesShipping":{"properties":{"carrierProductCategory":{"$ref":"#/components/schemas/CarrierProductCategory"},"desiredDeliveryTime":{"format":"date-time","type":"string"},"preferredCarriers":{"items":{"$ref":"#/components/schemas/PreferredCarrier"},"type":"array"},"preferredCarriersWithProduct":{"items":{"$ref":"#/components/schemas/PreferredCarrierWithProduct"},"type":"array"},"preselectedFacilities":{"items":{"$ref":"#/components/schemas/PreselectedFacility"},"type":"array"},"serviceLevel":{"description":"DELIVERY: The parcel will reach the recipient according to the cycle time of the carrier, typically 1-3 days when shipping nationaly. SAMEDAY: The parcel will reach the recipient the same day when ordering.","enum":["DELIVERY","SAMEDAY"],"type":"string"}},"type":"object","title":"DeliveryPreferencesShipping","description":"DeliveryPreferencesShipping"},"CarrierProductCategory":{"description":"Desired product class to choose when ordering a label, this is not a carrier specific value","enum":["STANDARD","EXPRESS","VALUE","FORWARDING"],"type":"string","title":"CarrierProductCategory"},"PreferredCarrier":{"description":"Keys of the preferred carriers to handle out the order","type":"string","title":"PreferredCarrier"},"PreferredCarrierWithProduct":{"additionalProperties":false,"properties":{"carrierKey":{"type":"string"},"carrierProduct":{"type":"string"},"carrierServices":{"items":{"$ref":"#/components/schemas/CarrierServices"},"type":"array"}},"required":["carrierKey"],"title":"PreferredCarrierWithProduct","description":"PreferredCarrierWithProduct"},"CarrierServices":{"description":"Services which should be booked from carrier","enum":["SIGNATURE","CUSTOMER_SIGNATURE","ADULT_SIGNATURE","SATURDAY_DELIVERY","IDENTITY_CHECK_COMPANY","IDENTITY_CHECK_PRIVATE","ADDITIONAL_TRANSPORTATION_INSURANCE"],"type":"string","title":"CarrierServices"},"PreselectedFacility":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"facilityRef":{"description":"Reference to the facility which is supposed to fulfill the order.","type":"string"},"tenantFacilityId":{"description":"Reference to the facility which is supposed to fulfill the order.","type":"string"}},"type":"object","title":"PreselectedFacility","description":"PreselectedFacility"},"OrderLineItemForCreation":{"additionalProperties":false,"properties":{"allowedSubstitutes":{"description":"Array of allowed substitutes for given orderLineItem. If an empty array is provided, no substitute is allowed for this orderLineItem. If allowedSubstitutes is not provided, this configured substitutes on listing level will be available","items":{"$ref":"#/components/schemas/Substitute"},"type":"array"},"article":{"$ref":"#/components/schemas/OrderLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to the orderline. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"measurementValidation":{"$ref":"#/components/schemas/MeasurementValidation"},"quantity":{"description":"quantity of the specific article that has been ordered","format":"int64","minimum":1,"type":"integer"},"scannableCodes":{"items":{"description":"Codes, that identify the article","type":"string"},"type":"array"},"secondaryMeasurementUnitKey":{"description":"Secondary identifier for items unit of measurement.","type":"string"},"secondaryQuantity":{"description":"Secondary quantity of the specific article that has been ordered","format":"int64","minimum":0,"type":"integer"},"shopPrice":{"description":"@deprecated price per piece of this line item Use attributes instead (see: <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">customization by attributes</a>)\n","type":"number"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["article","quantity"],"type":"object","title":"OrderLineItemForCreation","description":"OrderLineItemForCreation"},"Substitute":{"properties":{"attributes":{"items":{"$ref":"#/components/schemas/SubstituteAttributeItem"},"maxItems":40,"type":"array"},"imageUrl":{"type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"measurementValidation":{"$ref":"#/components/schemas/MeasurementValidation"},"priority":{"description":"This field allows you to rank substitutes against each other. The lowest number is the most preferrable substitute.","minimum":0,"type":"number"},"scannableCodes":{"items":{"description":"Strings, that identify the substitute article","type":"string"},"type":"array"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"tenantArticleId":{"type":"string"},"title":{"type":"string"}},"required":["title","tenantArticleId"],"type":"object","xml":{"name":"Substitute"},"title":"Substitute","description":"Substitute"},"SubstituteAttributeItem":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItem"}],"title":"SubstituteAttributeItem","description":"SubstituteAttributeItem"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"MeasurementValidation":{"properties":{"overPickHardTolerancePercentage":{"description":"Allowed hard over pick deviation tolerance.","minimum":0,"type":"number"},"overPickSoftTolerancePercentage":{"description":"Allowed soft over pick deviation tolerance.","minimum":0,"type":"number"},"shortPickHardTolerancePercentage":{"description":"Allowed hard short pick deviation tolerance.","maximum":100,"minimum":0,"type":"number"},"shortPickSoftTolerancePercentage":{"description":"Allowed soft short pick deviation tolerance.","maximum":100,"minimum":0,"type":"number"}},"title":"MeasurementValidation","description":"MeasurementValidation"},"OrderLineItemArticle":{"allOf":[{"$ref":"#/components/schemas/AbstractArticle"},{"properties":{"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients.\nDetails about usage can be found <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/OrderArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"@deprecated Please use customAttributes in OrderLineItem.\n","nullable":true,"type":"object"}},"type":"object"}],"xml":{"name":"OrderLineItemArticle"},"title":"OrderLineItemArticle","description":"OrderLineItemArticle"},"AbstractArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["tenantArticleId","title"],"title":"AbstractArticle","type":"object","description":"AbstractArticle"},"OrderArticleAttributeItem":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItem"}],"title":"OrderArticleAttributeItem","description":"OrderArticleAttributeItem"},"TagReference":{"properties":{"id":{"type":"string"},"value":{"type":"string"}},"required":["value","id"],"title":"TagReference","description":"TagReference"},"OrderPaymentInfoForCreation":{"additionalProperties":false,"properties":{"methodLocalized":{"$ref":"#/components/schemas/LocaleString"},"currency":{"description":"The currency in which the consumer paid with","type":"string"}},"type":"object","title":"OrderPaymentInfoForCreation","description":"OrderPaymentInfoForCreation"},"OrderPromisesOptions":{"additionalProperties":false,"properties":{"validUntil":{"description":"The date the promised order will become invalid and is cancelled automatically, when not transformed into an actual order.","format":"date-time","type":"string"}},"required":["validUntil"],"type":"object","xml":{"name":"OrderPromisesOptions"},"title":"OrderPromisesOptions","description":"OrderPromisesOptions"},"SourceRef":{"additionalProperties":false,"properties":{"sourceRef":{"type":"string"}},"required":["sourceRef"],"type":"object","title":"SourceRef","description":"SourceRef"},"TenantSourceId":{"additionalProperties":false,"properties":{"tenantSourceId":{"type":"string"}},"required":["tenantSourceId"],"type":"object","title":"TenantSourceId","description":"TenantSourceId"},"OrderStatus":{"description":"The state of the order. Initially it is OPEN.","enum":["OPEN","CANCELLED","PROMISED","LOCKED","OBSOLETE"],"type":"string","title":"OrderStatus"},"OrderStatusReason":{"description":"Order Status Reason.","properties":{"reason":{"description":"The reason for setting this order status","type":"string"},"status":{"$ref":"#/components/schemas/OrderStatus"}},"required":["reason","status"],"title":"OrderStatusReason"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"Order":{"allOf":[{"$ref":"#/components/schemas/OrderForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"anonymized":{"description":"Indicates if gdpr related data was anonymized","type":"boolean"},"cancelationReason":{"$ref":"#/components/schemas/CancelationReason"},"customServices":{"items":{"$ref":"#/components/schemas/CustomServiceReference"},"minItems":1,"type":"array"},"id":{"description":"The id of this order. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"orderLineItems":{"items":{"$ref":"#/components/schemas/OrderLineItem"},"type":"array"},"paymentInfo":{"$ref":"#/components/schemas/OrderPaymentInfo"},"processId":{"description":"Id of the global process related to this entity. For example used for starting the GDPR process and others.","type":"string"},"schemaVersion":{"type":"number"},"status":{"$ref":"#/components/schemas/OrderStatus"},"updateDetails":{"items":{"$ref":"#/components/schemas/OrderUpdateDetail"},"minItems":1,"type":"array"}},"required":["id","status","orderLineItems","processId"],"type":"object"}],"xml":{"name":"Order"},"title":"Order","description":"Order"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CancelationReason":{"allOf":[{"$ref":"#/components/schemas/AbstractReason"}],"properties":{"action":{"enum":["CANCELATION"],"type":"string"}},"required":["action"],"type":"object","xml":{"name":"CancelationReason"},"title":"CancelationReason","description":"CancelationReason"},"AbstractReason":{"allOf":[{"$ref":"#/components/schemas/AbstractReasonForCreation"},{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"action":{"description":"The action this reason can be attached to.","type":"string"},"id":{"description":"The id of the Reason","type":"string"}},"required":["id","action"],"type":"object","xml":{"name":"AbstractReason"},"title":"AbstractReason","description":"AbstractReason"},"AbstractReasonForCreation":{"additionalProperties":false,"properties":{"reasonLocalized":{"$ref":"#/components/schemas/LocaleString"},"reason":{"description":"Text explaining the reason for a supported action.","type":"string"}},"required":["reason","reasonLocalized"],"type":"object","xml":{"name":"AbstractReasonForCreation"},"title":"AbstractReasonForCreation","description":"AbstractReasonForCreation"},"CustomServiceReference":{"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItem"},"type":"array"},"id":{"type":"string"}},"required":["customServiceDefinition","articleItems","customServiceItems","id"],"type":"object","title":"CustomServiceReference","description":"CustomServiceReference"},"CustomServiceItem":{"allOf":[{"$ref":"#/components/schemas/CustomServiceItemForCreation"}],"properties":{"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItem"},"type":"array"},"id":{"type":"string"}},"required":["id","customServiceItems","articleItems","customServiceDefinition"],"type":"object","title":"CustomServiceItem","description":"CustomServiceItem"},"OrderLineItem":{"allOf":[{"$ref":"#/components/schemas/OrderLineItemForCreation"},{"properties":{"id":{"description":"The id of this orderline. It is generated during creation automatically by the API and suits as the primary identifier of the described line.","type":"string"}},"required":["id"],"type":"object"}],"title":"OrderLineItem","description":"OrderLineItem"},"OrderPaymentInfo":{"additionalProperties":false,"properties":{"methodLocalized":{"$ref":"#/components/schemas/LocaleString"},"currency":{"description":"The currency in which the consumer paid with","type":"string"},"method":{"description":"Localized value from methodLocalized","type":"string"}},"type":"object","title":"OrderPaymentInfo","description":"OrderPaymentInfo"},"OrderUpdateDetail":{"properties":{"changes":{"$ref":"#/components/schemas/OrderUpdateDetailChanges"},"comment":{"type":"string"},"created":{"description":"The date this update was done.","format":"date-time","type":"string"},"user":{"type":"string"}},"required":["created","changes"],"type":"object","title":"OrderUpdateDetail","description":"OrderUpdateDetail"},"OrderUpdateDetailChanges":{"properties":{"consumer":{"$ref":"#/components/schemas/OrderForCreationConsumer"},"customAttributes":{"description":"Attributes that can be added to the order. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","nullable":true,"type":"object"},"orderLineItems":{"description":"Updates the order line items of the order. All order lines must be included, only the included lines will remain after the update.","items":{"$ref":"#/components/schemas/OrderLineItemForUpdate"},"nullable":true,"type":"array"},"preferredHandlingTime":{"description":"Updates the preferred handling time for ship-from-store orders or the provisioning time for click-and-collect orders.","format":"date-time","type":"string"}},"type":"object","title":"OrderUpdateDetailChanges","description":"OrderUpdateDetailChanges"},"OrderLineItemForUpdate":{"properties":{"article":{"$ref":"#/components/schemas/OrderLineItemArticleForUpdate"},"id":{"description":"The id of this order line item. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"quantity":{"description":"The quantity of this order line item.","type":"number"}},"title":"OrderLineItemForUpdate","description":"OrderLineItemForUpdate"},"OrderLineItemArticleForUpdate":{"allOf":[{"$ref":"#/components/schemas/AbstractArticleForCreation"},{"properties":{"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients.\nDetails about usage can be found <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/OrderArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"@deprecated Please use customAttributes in OrderLineItem.\n","nullable":true,"type":"object"}},"type":"object"}],"xml":{"name":"OrderLineItemArticleForUpdate"},"title":"OrderLineItemArticleForUpdate","description":"OrderLineItemArticleForUpdate"},"AbstractArticleForCreation":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["title"],"title":"AbstractArticleForCreation","type":"object","description":"AbstractArticleForCreation"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/orders":{"post":{"description":"","operationId":"addOrder","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/OrderForCreation"}}},"description":"Order object supplied by your shop instance.","required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Order"}}},"description":"The order was successfully created. The Location header contains the URL of the order."},"400":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Invalid input. See response for details"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"}},"summary":"Create order","tags":["Orders (DOMS)"]}}}}
```

## GET /api/orders/{orderId}

> Get order

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"DOMS endpoints to create, retrieve, update, and manage customer orders.","name":"Orders (DOMS)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"Order":{"allOf":[{"$ref":"#/components/schemas/OrderForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"anonymized":{"description":"Indicates if gdpr related data was anonymized","type":"boolean"},"cancelationReason":{"$ref":"#/components/schemas/CancelationReason"},"customServices":{"items":{"$ref":"#/components/schemas/CustomServiceReference"},"minItems":1,"type":"array"},"id":{"description":"The id of this order. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"orderLineItems":{"items":{"$ref":"#/components/schemas/OrderLineItem"},"type":"array"},"paymentInfo":{"$ref":"#/components/schemas/OrderPaymentInfo"},"processId":{"description":"Id of the global process related to this entity. For example used for starting the GDPR process and others.","type":"string"},"schemaVersion":{"type":"number"},"status":{"$ref":"#/components/schemas/OrderStatus"},"updateDetails":{"items":{"$ref":"#/components/schemas/OrderUpdateDetail"},"minItems":1,"type":"array"}},"required":["id","status","orderLineItems","processId"],"type":"object"}],"xml":{"name":"Order"},"title":"Order","description":"Order"},"OrderForCreation":{"additionalProperties":false,"properties":{"consumer":{"$ref":"#/components/schemas/OrderForCreationConsumer"},"customAttributes":{"description":"Attributes that can be added to the order. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"customServices":{"items":{"$ref":"#/components/schemas/CustomServiceReferenceForCreation"},"minItems":1,"type":"array"},"deliveryPreferences":{"$ref":"#/components/schemas/DeliveryPreferences"},"orderDate":{"description":"The date this order was created at the supplying system.","format":"date-time","type":"string"},"orderLineItems":{"items":{"$ref":"#/components/schemas/OrderLineItemForCreation"},"type":"array"},"paymentInfo":{"$ref":"#/components/schemas/OrderPaymentInfoForCreation"},"promisesOptions":{"$ref":"#/components/schemas/OrderPromisesOptions"},"source":{"description":"Defines the source of this order. This field is not required, if the order is created based on an external system.","oneOf":[{"$ref":"#/components/schemas/SourceRef"},{"$ref":"#/components/schemas/TenantSourceId"}],"type":"object"},"status":{"$ref":"#/components/schemas/OrderStatus"},"statusReasons":{"items":{"$ref":"#/components/schemas/OrderStatusReason"},"type":"array"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"maxItems":100,"minItems":1,"type":"array"},"tenantOrderId":{"description":"Field can be used as a reference number in foreign systems, for example as a reference to the source system's identifier for this order.","type":"string"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"minItems":1,"type":"array"}},"required":["orderDate","orderLineItems","consumer"],"type":"object","xml":{"name":"Order"},"title":"OrderForCreation","description":"OrderForCreation"},"OrderForCreationConsumer":{"properties":{"addresses":{"items":{"$ref":"#/components/schemas/ConsumerAddress"},"type":"array"},"consumerId":{"description":"The id of the consumer.","type":"string"},"customAttributes":{"description":"Attributes that can be added to the consumer. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"email":{"deprecated":true,"description":"@deprecated The email address of the consumer. Use email in addresses array\n","format":"email","type":"string"},"facilityRef":{"description":"ID of the facility, if the recipient is a facility.","type":"string"},"tenantFacilityId":{"description":"tenantFacilityId of the facility, if the recipient is a facility","type":"string"}},"type":"object","title":"OrderForCreationConsumer","description":"OrderForCreationConsumer"},"ConsumerAddress":{"allOf":[{"$ref":"#/components/schemas/Address"}],"properties":{"addressType":{"$ref":"#/components/schemas/AddressType"},"companyName":{"type":"string"},"coordinates":{"$ref":"#/components/schemas/Coordinates"},"email":{"format":"email","minLength":1,"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"personalTitle":{"type":"string"},"salutation":{"type":"string"}},"type":"object","title":"ConsumerAddress","description":"ConsumerAddress"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"AddressType":{"description":"Type of this address, used e.g. for communication with the carrier. Use POSTAL_ADDRESS for the address where the order should be shipped to, INVOICE_ADDRESS for the address where the invoice is sent to and PARCEL_LOCKER if a parcel locker is used for this order.","enum":["POSTAL_ADDRESS","PARCEL_LOCKER","INVOICE_ADDRESS"],"type":"string","title":"AddressType"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"CustomServiceReferenceForCreation":{"additionalProperties":false,"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItemForCreation"},"type":"array"}},"required":["customServiceDefinition","articleItems","customServiceItems"],"type":"object","title":"CustomServiceReferenceForCreation","description":"CustomServiceReferenceForCreation"},"ArticleItem":{"additionalProperties":false,"properties":{"quantity":{"minimum":1,"type":"number"},"tenantArticleRef":{"type":"string"}},"required":["quantity","tenantArticleRef"],"type":"object","title":"ArticleItem","description":"ArticleItem"},"CustomServiceDefinition":{"properties":{"additionalInformation":{"description":"Additional information necessary to fulfil the custom service","items":{"properties":{"additionalInformationRef":{"description":"A reference to the specific additional information of the custom service","type":"string"},"tenantAdditionalInformationId":{"description":"The id of the tenant specific additional information","type":"string"},"value":{"anyOf":[{"type":"string"},{"type":"integer"},{"type":"number"},{"type":"boolean"}],"description":"The value of the additional information"}},"required":["additionalInformationRef"],"type":"object"},"type":"array"},"customAttributes":{"description":"Attributes that can be added to the consumer. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"customServiceRef":{"description":"A reference to the custom service to be applied to the orderline items","type":"string"},"isBundled":{"description":"if true all articles below this service are intrpreted as a bundle","type":"boolean"},"tenantCustomServiceId":{"description":"The id of the tenant specific custom service","type":"string"}},"type":"object","title":"CustomServiceDefinition","description":"CustomServiceDefinition"},"CustomServiceItemForCreation":{"additionalProperties":false,"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItemForCreation"},"type":"array"}},"required":["customServiceItems","articleItems","customServiceDefinition"],"type":"object","title":"CustomServiceItemForCreation","description":"CustomServiceItemForCreation"},"DeliveryPreferences":{"additionalProperties":false,"properties":{"collect":{"items":{"$ref":"#/components/schemas/CollectDelivery"},"maxItems":1,"type":"array"},"reservationPreferences":{"$ref":"#/components/schemas/DeliveryReservationPreferences"},"shipping":{"$ref":"#/components/schemas/DeliveryPreferencesShipping"},"sourcingOptionRefs":{"description":"Id of the SourcingOptions","items":{"description":"Reference of a SourcingOptions","type":"string"},"type":"array"},"supplyingFacilities":{"description":"@deprecated Use supplyingFacilities under collect","items":{"description":"Reference of a Facility","type":"string"},"type":"array"},"targetTime":{"description":"At which time the result is expected.","format":"date-time","type":"string"}},"type":"object","title":"DeliveryPreferences","description":"DeliveryPreferences"},"CollectDelivery":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"facilityRef":{"description":"Reference to the facility where the consumer expects to collect the items","type":"string"},"paid":{"default":false,"description":"Indicates if the order is already paid.","type":"boolean"},"provisioningTime":{"description":"The point in time by which the order is supposed to be provisioned.","format":"date-time","type":"string"},"supplyingFacilities":{"deprecated":true,"description":"@deprecated Use supplyingFacilitiesConfigurations","items":{"description":"Reference of a Facility.","type":"string"},"type":"array"},"supplyingFacilitiesConfigurations":{"description":"References of facility that could supply contents of the order to another facility with specific configuration of its usage","items":{"$ref":"#/components/schemas/SupplyingFacilityConfiguration"},"type":"array"},"tenantFacilityId":{"description":"Reference to the facility where the consumer expects to collect the items.","type":"string"}},"type":"object","title":"CollectDelivery","description":"CollectDelivery"},"SupplyingFacilityConfiguration":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"deliveryEvents":{"items":{"$ref":"#/components/schemas/DeliveryEvent"},"type":"array"},"facilityRef":{"description":"ID of the facility.","type":"string"},"tenantFacilityId":{"description":"Reference to the facility.","type":"string"}},"required":["deliveryEvents"],"title":"SupplyingFacilityConfiguration","description":"SupplyingFacilityConfiguration"},"DeliveryEvent":{"properties":{"deliveryTarget":{"$ref":"#/components/schemas/DeliveryTarget"},"deliveryTrigger":{"enum":["DEFAULT"],"type":"string"}},"required":["deliveryTarget","deliveryTrigger"],"title":"DeliveryEvent","description":"DeliveryEvent"},"DeliveryTarget":{"description":"The destination for a delivery","enum":["SHIP_TO_STORE","SHIP_TO_CUSTOMER"],"type":"string","title":"DeliveryTarget"},"DeliveryReservationPreferences":{"properties":{"mode":{"$ref":"#/components/schemas/DeliveryReservationMode"},"reservationTime":{"format":"date-time","type":"string"}},"required":["mode"],"type":"object","title":"DeliveryReservationPreferences","description":"DeliveryReservationPreferences"},"DeliveryReservationMode":{"enum":["SCHEDULED","ASAP","ALAP"],"title":"DeliveryReservationMode","description":"DeliveryReservationMode"},"DeliveryPreferencesShipping":{"properties":{"carrierProductCategory":{"$ref":"#/components/schemas/CarrierProductCategory"},"desiredDeliveryTime":{"format":"date-time","type":"string"},"preferredCarriers":{"items":{"$ref":"#/components/schemas/PreferredCarrier"},"type":"array"},"preferredCarriersWithProduct":{"items":{"$ref":"#/components/schemas/PreferredCarrierWithProduct"},"type":"array"},"preselectedFacilities":{"items":{"$ref":"#/components/schemas/PreselectedFacility"},"type":"array"},"serviceLevel":{"description":"DELIVERY: The parcel will reach the recipient according to the cycle time of the carrier, typically 1-3 days when shipping nationaly. SAMEDAY: The parcel will reach the recipient the same day when ordering.","enum":["DELIVERY","SAMEDAY"],"type":"string"}},"type":"object","title":"DeliveryPreferencesShipping","description":"DeliveryPreferencesShipping"},"CarrierProductCategory":{"description":"Desired product class to choose when ordering a label, this is not a carrier specific value","enum":["STANDARD","EXPRESS","VALUE","FORWARDING"],"type":"string","title":"CarrierProductCategory"},"PreferredCarrier":{"description":"Keys of the preferred carriers to handle out the order","type":"string","title":"PreferredCarrier"},"PreferredCarrierWithProduct":{"additionalProperties":false,"properties":{"carrierKey":{"type":"string"},"carrierProduct":{"type":"string"},"carrierServices":{"items":{"$ref":"#/components/schemas/CarrierServices"},"type":"array"}},"required":["carrierKey"],"title":"PreferredCarrierWithProduct","description":"PreferredCarrierWithProduct"},"CarrierServices":{"description":"Services which should be booked from carrier","enum":["SIGNATURE","CUSTOMER_SIGNATURE","ADULT_SIGNATURE","SATURDAY_DELIVERY","IDENTITY_CHECK_COMPANY","IDENTITY_CHECK_PRIVATE","ADDITIONAL_TRANSPORTATION_INSURANCE"],"type":"string","title":"CarrierServices"},"PreselectedFacility":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"facilityRef":{"description":"Reference to the facility which is supposed to fulfill the order.","type":"string"},"tenantFacilityId":{"description":"Reference to the facility which is supposed to fulfill the order.","type":"string"}},"type":"object","title":"PreselectedFacility","description":"PreselectedFacility"},"OrderLineItemForCreation":{"additionalProperties":false,"properties":{"allowedSubstitutes":{"description":"Array of allowed substitutes for given orderLineItem. If an empty array is provided, no substitute is allowed for this orderLineItem. If allowedSubstitutes is not provided, this configured substitutes on listing level will be available","items":{"$ref":"#/components/schemas/Substitute"},"type":"array"},"article":{"$ref":"#/components/schemas/OrderLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to the orderline. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"measurementValidation":{"$ref":"#/components/schemas/MeasurementValidation"},"quantity":{"description":"quantity of the specific article that has been ordered","format":"int64","minimum":1,"type":"integer"},"scannableCodes":{"items":{"description":"Codes, that identify the article","type":"string"},"type":"array"},"secondaryMeasurementUnitKey":{"description":"Secondary identifier for items unit of measurement.","type":"string"},"secondaryQuantity":{"description":"Secondary quantity of the specific article that has been ordered","format":"int64","minimum":0,"type":"integer"},"shopPrice":{"description":"@deprecated price per piece of this line item Use attributes instead (see: <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">customization by attributes</a>)\n","type":"number"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["article","quantity"],"type":"object","title":"OrderLineItemForCreation","description":"OrderLineItemForCreation"},"Substitute":{"properties":{"attributes":{"items":{"$ref":"#/components/schemas/SubstituteAttributeItem"},"maxItems":40,"type":"array"},"imageUrl":{"type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"measurementValidation":{"$ref":"#/components/schemas/MeasurementValidation"},"priority":{"description":"This field allows you to rank substitutes against each other. The lowest number is the most preferrable substitute.","minimum":0,"type":"number"},"scannableCodes":{"items":{"description":"Strings, that identify the substitute article","type":"string"},"type":"array"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"tenantArticleId":{"type":"string"},"title":{"type":"string"}},"required":["title","tenantArticleId"],"type":"object","xml":{"name":"Substitute"},"title":"Substitute","description":"Substitute"},"SubstituteAttributeItem":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItem"}],"title":"SubstituteAttributeItem","description":"SubstituteAttributeItem"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"MeasurementValidation":{"properties":{"overPickHardTolerancePercentage":{"description":"Allowed hard over pick deviation tolerance.","minimum":0,"type":"number"},"overPickSoftTolerancePercentage":{"description":"Allowed soft over pick deviation tolerance.","minimum":0,"type":"number"},"shortPickHardTolerancePercentage":{"description":"Allowed hard short pick deviation tolerance.","maximum":100,"minimum":0,"type":"number"},"shortPickSoftTolerancePercentage":{"description":"Allowed soft short pick deviation tolerance.","maximum":100,"minimum":0,"type":"number"}},"title":"MeasurementValidation","description":"MeasurementValidation"},"OrderLineItemArticle":{"allOf":[{"$ref":"#/components/schemas/AbstractArticle"},{"properties":{"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients.\nDetails about usage can be found <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/OrderArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"@deprecated Please use customAttributes in OrderLineItem.\n","nullable":true,"type":"object"}},"type":"object"}],"xml":{"name":"OrderLineItemArticle"},"title":"OrderLineItemArticle","description":"OrderLineItemArticle"},"AbstractArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["tenantArticleId","title"],"title":"AbstractArticle","type":"object","description":"AbstractArticle"},"OrderArticleAttributeItem":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItem"}],"title":"OrderArticleAttributeItem","description":"OrderArticleAttributeItem"},"TagReference":{"properties":{"id":{"type":"string"},"value":{"type":"string"}},"required":["value","id"],"title":"TagReference","description":"TagReference"},"OrderPaymentInfoForCreation":{"additionalProperties":false,"properties":{"methodLocalized":{"$ref":"#/components/schemas/LocaleString"},"currency":{"description":"The currency in which the consumer paid with","type":"string"}},"type":"object","title":"OrderPaymentInfoForCreation","description":"OrderPaymentInfoForCreation"},"OrderPromisesOptions":{"additionalProperties":false,"properties":{"validUntil":{"description":"The date the promised order will become invalid and is cancelled automatically, when not transformed into an actual order.","format":"date-time","type":"string"}},"required":["validUntil"],"type":"object","xml":{"name":"OrderPromisesOptions"},"title":"OrderPromisesOptions","description":"OrderPromisesOptions"},"SourceRef":{"additionalProperties":false,"properties":{"sourceRef":{"type":"string"}},"required":["sourceRef"],"type":"object","title":"SourceRef","description":"SourceRef"},"TenantSourceId":{"additionalProperties":false,"properties":{"tenantSourceId":{"type":"string"}},"required":["tenantSourceId"],"type":"object","title":"TenantSourceId","description":"TenantSourceId"},"OrderStatus":{"description":"The state of the order. Initially it is OPEN.","enum":["OPEN","CANCELLED","PROMISED","LOCKED","OBSOLETE"],"type":"string","title":"OrderStatus"},"OrderStatusReason":{"description":"Order Status Reason.","properties":{"reason":{"description":"The reason for setting this order status","type":"string"},"status":{"$ref":"#/components/schemas/OrderStatus"}},"required":["reason","status"],"title":"OrderStatusReason"},"Sticker":{"additionalProperties":false,"properties":{"nameLocalized":{"$ref":"#/components/schemas/LocaleString","description":"Dictionary of possible translations, min 1 entry, max 14 characters per description"},"color":{"description":"optional color coding for the sticker","type":"string"},"key":{"description":"unique identifier","type":"string"},"name":{"description":"Translated display name","type":"string"},"priority":{"description":"priority of the given sticker","format":"int64","maximum":10000,"minimum":1,"type":"integer"}},"required":["key","nameLocalized","priority"],"title":"Sticker","description":"Sticker"},"VersionedResource":{"properties":{"created":{"description":"The date this entity was created at the platform. This value is generated by the service.","format":"date-time","type":"string"},"lastModified":{"description":"The date this entity was modified last. This value is generated by the service.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"type":"object","title":"VersionedResource","description":"VersionedResource"},"CancelationReason":{"allOf":[{"$ref":"#/components/schemas/AbstractReason"}],"properties":{"action":{"enum":["CANCELATION"],"type":"string"}},"required":["action"],"type":"object","xml":{"name":"CancelationReason"},"title":"CancelationReason","description":"CancelationReason"},"AbstractReason":{"allOf":[{"$ref":"#/components/schemas/AbstractReasonForCreation"},{"$ref":"#/components/schemas/VersionedResource"}],"properties":{"action":{"description":"The action this reason can be attached to.","type":"string"},"id":{"description":"The id of the Reason","type":"string"}},"required":["id","action"],"type":"object","xml":{"name":"AbstractReason"},"title":"AbstractReason","description":"AbstractReason"},"AbstractReasonForCreation":{"additionalProperties":false,"properties":{"reasonLocalized":{"$ref":"#/components/schemas/LocaleString"},"reason":{"description":"Text explaining the reason for a supported action.","type":"string"}},"required":["reason","reasonLocalized"],"type":"object","xml":{"name":"AbstractReasonForCreation"},"title":"AbstractReasonForCreation","description":"AbstractReasonForCreation"},"CustomServiceReference":{"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItem"},"type":"array"},"id":{"type":"string"}},"required":["customServiceDefinition","articleItems","customServiceItems","id"],"type":"object","title":"CustomServiceReference","description":"CustomServiceReference"},"CustomServiceItem":{"allOf":[{"$ref":"#/components/schemas/CustomServiceItemForCreation"}],"properties":{"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItem"},"type":"array"},"id":{"type":"string"}},"required":["id","customServiceItems","articleItems","customServiceDefinition"],"type":"object","title":"CustomServiceItem","description":"CustomServiceItem"},"OrderLineItem":{"allOf":[{"$ref":"#/components/schemas/OrderLineItemForCreation"},{"properties":{"id":{"description":"The id of this orderline. It is generated during creation automatically by the API and suits as the primary identifier of the described line.","type":"string"}},"required":["id"],"type":"object"}],"title":"OrderLineItem","description":"OrderLineItem"},"OrderPaymentInfo":{"additionalProperties":false,"properties":{"methodLocalized":{"$ref":"#/components/schemas/LocaleString"},"currency":{"description":"The currency in which the consumer paid with","type":"string"},"method":{"description":"Localized value from methodLocalized","type":"string"}},"type":"object","title":"OrderPaymentInfo","description":"OrderPaymentInfo"},"OrderUpdateDetail":{"properties":{"changes":{"$ref":"#/components/schemas/OrderUpdateDetailChanges"},"comment":{"type":"string"},"created":{"description":"The date this update was done.","format":"date-time","type":"string"},"user":{"type":"string"}},"required":["created","changes"],"type":"object","title":"OrderUpdateDetail","description":"OrderUpdateDetail"},"OrderUpdateDetailChanges":{"properties":{"consumer":{"$ref":"#/components/schemas/OrderForCreationConsumer"},"customAttributes":{"description":"Attributes that can be added to the order. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","nullable":true,"type":"object"},"orderLineItems":{"description":"Updates the order line items of the order. All order lines must be included, only the included lines will remain after the update.","items":{"$ref":"#/components/schemas/OrderLineItemForUpdate"},"nullable":true,"type":"array"},"preferredHandlingTime":{"description":"Updates the preferred handling time for ship-from-store orders or the provisioning time for click-and-collect orders.","format":"date-time","type":"string"}},"type":"object","title":"OrderUpdateDetailChanges","description":"OrderUpdateDetailChanges"},"OrderLineItemForUpdate":{"properties":{"article":{"$ref":"#/components/schemas/OrderLineItemArticleForUpdate"},"id":{"description":"The id of this order line item. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"quantity":{"description":"The quantity of this order line item.","type":"number"}},"title":"OrderLineItemForUpdate","description":"OrderLineItemForUpdate"},"OrderLineItemArticleForUpdate":{"allOf":[{"$ref":"#/components/schemas/AbstractArticleForCreation"},{"properties":{"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients.\nDetails about usage can be found <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/OrderArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"@deprecated Please use customAttributes in OrderLineItem.\n","nullable":true,"type":"object"}},"type":"object"}],"xml":{"name":"OrderLineItemArticleForUpdate"},"title":"OrderLineItemArticleForUpdate","description":"OrderLineItemArticleForUpdate"},"AbstractArticleForCreation":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["title"],"title":"AbstractArticleForCreation","type":"object","description":"AbstractArticleForCreation"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/orders/{orderId}":{"get":{"description":"","operationId":"getOrder","parameters":[{"description":"ID of order you want to get","in":"path","name":"orderId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Order"}}},"description":"Order was found & you were allowed to access it. The result is in the body."},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this endpoint"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Entity not found"}},"summary":"Get order","tags":["Orders (DOMS)"]}}}}
```

## PATCH /api/orders/{orderId}

> Update order

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"DOMS endpoints to create, retrieve, update, and manage customer orders.","name":"Orders (DOMS)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"OrderForUpdate":{"additionalProperties":false,"properties":{"comment":{"description":"A comment for updating this order.","type":"string"},"consumer":{"$ref":"#/components/schemas/OrderForCreationConsumer"},"customAttributes":{"description":"Attributes that can be added to the order. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","nullable":true,"type":"object"},"orderLineItems":{"description":"Updates the order line items of the order. All order lines must be included, only the included lines will remain after the update.","items":{"$ref":"#/components/schemas/OrderLineItemForUpdate"},"nullable":true,"type":"array"},"preferredHandlingTime":{"description":"Updates the preferred handling time for ship-from-store orders or the provisioning time for click-and-collect orders.","format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms.","format":"int64","type":"integer"}},"required":["version"],"title":"OrderForUpdate","description":"OrderForUpdate"},"OrderForCreationConsumer":{"properties":{"addresses":{"items":{"$ref":"#/components/schemas/ConsumerAddress"},"type":"array"},"consumerId":{"description":"The id of the consumer.","type":"string"},"customAttributes":{"description":"Attributes that can be added to the consumer. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"email":{"deprecated":true,"description":"@deprecated The email address of the consumer. Use email in addresses array\n","format":"email","type":"string"},"facilityRef":{"description":"ID of the facility, if the recipient is a facility.","type":"string"},"tenantFacilityId":{"description":"tenantFacilityId of the facility, if the recipient is a facility","type":"string"}},"type":"object","title":"OrderForCreationConsumer","description":"OrderForCreationConsumer"},"ConsumerAddress":{"allOf":[{"$ref":"#/components/schemas/Address"}],"properties":{"addressType":{"$ref":"#/components/schemas/AddressType"},"companyName":{"type":"string"},"coordinates":{"$ref":"#/components/schemas/Coordinates"},"email":{"format":"email","minLength":1,"type":"string"},"firstName":{"type":"string"},"lastName":{"type":"string"},"personalTitle":{"type":"string"},"salutation":{"type":"string"}},"type":"object","title":"ConsumerAddress","description":"ConsumerAddress"},"Address":{"properties":{"additionalAddressInfo":{"type":"string"},"city":{"pattern":"^.+$","type":"string"},"country":{"description":"A two-digit country code as per ISO 3166-1 alpha-2","pattern":"^[A-Z]{2}$","type":"string"},"customAttributes":{"description":"Attributes that can be added to the address. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"houseNumber":{"pattern":"^.+$","type":"string"},"phoneNumbers":{"items":{"properties":{"customAttributes":{"description":"Attributes that can be added to the phonenumber. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"label":{"description":"Can be used to give a description for the number, like \"private\", \"business number\", etc.","type":"string"},"type":{"enum":["MOBILE","PHONE"],"type":"string"},"value":{"description":"The number itself. We do not enforce any format (yet).","type":"string"}},"required":["value","type"],"type":"object"},"type":"array"},"postalCode":{"pattern":"^.+$","type":"string"},"province":{"pattern":"^.+$","type":"string"},"street":{"pattern":"^.+$","type":"string"}},"required":["street","city","postalCode","country"],"type":"object","title":"Address","description":"Address"},"AddressType":{"description":"Type of this address, used e.g. for communication with the carrier. Use POSTAL_ADDRESS for the address where the order should be shipped to, INVOICE_ADDRESS for the address where the invoice is sent to and PARCEL_LOCKER if a parcel locker is used for this order.","enum":["POSTAL_ADDRESS","PARCEL_LOCKER","INVOICE_ADDRESS"],"type":"string","title":"AddressType"},"Coordinates":{"description":"Coordinates of the WGS84 geodetic reference system in Mercator projection, as used e.g. by the Google Maps API","properties":{"lat":{"description":"Latitude value","type":"number"},"lon":{"description":"Longitude value","type":"number"}},"required":["lat","lon"],"type":"object","title":"Coordinates"},"OrderLineItemForUpdate":{"properties":{"article":{"$ref":"#/components/schemas/OrderLineItemArticleForUpdate"},"id":{"description":"The id of this order line item. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"quantity":{"description":"The quantity of this order line item.","type":"number"}},"title":"OrderLineItemForUpdate","description":"OrderLineItemForUpdate"},"OrderLineItemArticleForUpdate":{"allOf":[{"$ref":"#/components/schemas/AbstractArticleForCreation"},{"properties":{"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients.\nDetails about usage can be found <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/OrderArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"@deprecated Please use customAttributes in OrderLineItem.\n","nullable":true,"type":"object"}},"type":"object"}],"xml":{"name":"OrderLineItemArticleForUpdate"},"title":"OrderLineItemArticleForUpdate","description":"OrderLineItemArticleForUpdate"},"AbstractArticleForCreation":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this article. Please make sure that no authentication is required to fetch the image!","type":"string"},"tenantArticleId":{"description":"This is a reference to an article number","type":"string"},"title":{"description":"The title of the product","type":"string"},"weight":{"description":"weight value is in gram","minimum":0,"type":"number"}},"required":["title"],"title":"AbstractArticleForCreation","type":"object","description":"AbstractArticleForCreation"},"LocaleString":{"additionalProperties":{"type":"string"},"description":"Provides Localized values. The key is the locale, the value is the translation. https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/localization","title":"LocaleString","type":"object"},"OrderArticleAttributeItem":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItem"}],"title":"OrderArticleAttributeItem","description":"OrderArticleAttributeItem"},"ArticleAttributeItem":{"properties":{"valueLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category"},"keyLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the key of the attribute. This can be only filled with a descriptive category. Excluding for %%subtitle%%"},"category":{"description":"This category is used by OCFF to customize implemented processes.\nCategorized attributes are used by various processes and tools\nthroughout our platform. For a complete list of possible categories\nand the correct use of those please refer to the documentation.\nDefault value: miscellaneous","enum":["descriptive","miscellaneous","pickingSequence","customs","insurance","shop","dimensions","carrierService","salesPrice"],"type":"string"},"context":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItemContext"}],"description":"Context for salesPrice category and valuePerUnit key. Can only be set via Listing endpoints."},"key":{"description":"Providing the key %%subtitle%% (see example) here will cause the\nvalue to appear for example in the App directly under the title.\nWith all other attributes also the key will be displayed in the\n clients.","minLength":1,"type":"string"},"priority":{"description":"This value gives the priority in the respective attribute category.\nThe lower the value the higher is the priority, e.g. priority 1 is\nhigher than priority 10. Attributes that have the highest priority\nmight be selected for display in different articles of OCFF. Default\nValue is 1001. For details please contact the product owners.","format":"int64","maximum":1001,"minimum":1,"type":"integer"},"type":{"default":"STRING","description":"The type of the attribute.","enum":["STRING","NUMBER","CURRENCY","BOOLEAN"],"type":"string"},"value":{"minLength":1,"type":"string"}},"required":["key","value"],"title":"ArticleAttributeItem","type":"object","description":"ArticleAttributeItem"},"ArticleAttributeItemContext":{"properties":{"type":{"description":"Indicates the entity type the value refers to.","enum":["FACILITY_GROUP","FACILITY","TAG_REFERENCE"],"type":"string"},"value":{"description":"Holds the reference to the entity the attribute refers to.","minLength":1,"type":"string"}},"required":["type","value"],"title":"ArticleAttributeItemContext","type":"object","description":"ArticleAttributeItemContext"},"Order":{"allOf":[{"$ref":"#/components/schemas/OrderForCreation"},{"$ref":"#/components/schemas/VersionedResource"},{"properties":{"anonymized":{"description":"Indicates if gdpr related data was anonymized","type":"boolean"},"cancelationReason":{"$ref":"#/components/schemas/CancelationReason"},"customServices":{"items":{"$ref":"#/components/schemas/CustomServiceReference"},"minItems":1,"type":"array"},"id":{"description":"The id of this order. It is generated during creation automatically and suits as the primary identifier of the described entity.","type":"string"},"orderLineItems":{"items":{"$ref":"#/components/schemas/OrderLineItem"},"type":"array"},"paymentInfo":{"$ref":"#/components/schemas/OrderPaymentInfo"},"processId":{"description":"Id of the global process related to this entity. For example used for starting the GDPR process and others.","type":"string"},"schemaVersion":{"type":"number"},"status":{"$ref":"#/components/schemas/OrderStatus"},"updateDetails":{"items":{"$ref":"#/components/schemas/OrderUpdateDetail"},"minItems":1,"type":"array"}},"required":["id","status","orderLineItems","processId"],"type":"object"}],"xml":{"name":"Order"},"title":"Order","description":"Order"},"OrderForCreation":{"additionalProperties":false,"properties":{"consumer":{"$ref":"#/components/schemas/OrderForCreationConsumer"},"customAttributes":{"description":"Attributes that can be added to the order. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"customServices":{"items":{"$ref":"#/components/schemas/CustomServiceReferenceForCreation"},"minItems":1,"type":"array"},"deliveryPreferences":{"$ref":"#/components/schemas/DeliveryPreferences"},"orderDate":{"description":"The date this order was created at the supplying system.","format":"date-time","type":"string"},"orderLineItems":{"items":{"$ref":"#/components/schemas/OrderLineItemForCreation"},"type":"array"},"paymentInfo":{"$ref":"#/components/schemas/OrderPaymentInfoForCreation"},"promisesOptions":{"$ref":"#/components/schemas/OrderPromisesOptions"},"source":{"description":"Defines the source of this order. This field is not required, if the order is created based on an external system.","oneOf":[{"$ref":"#/components/schemas/SourceRef"},{"$ref":"#/components/schemas/TenantSourceId"}],"type":"object"},"status":{"$ref":"#/components/schemas/OrderStatus"},"statusReasons":{"items":{"$ref":"#/components/schemas/OrderStatusReason"},"type":"array"},"stickers":{"items":{"$ref":"#/components/schemas/Sticker"},"maxItems":100,"minItems":1,"type":"array"},"tenantOrderId":{"description":"Field can be used as a reference number in foreign systems, for example as a reference to the source system's identifier for this order.","type":"string"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"minItems":1,"type":"array"}},"required":["orderDate","orderLineItems","consumer"],"type":"object","xml":{"name":"Order"},"title":"OrderForCreation","description":"OrderForCreation"},"CustomServiceReferenceForCreation":{"additionalProperties":false,"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItemForCreation"},"type":"array"}},"required":["customServiceDefinition","articleItems","customServiceItems"],"type":"object","title":"CustomServiceReferenceForCreation","description":"CustomServiceReferenceForCreation"},"ArticleItem":{"additionalProperties":false,"properties":{"quantity":{"minimum":1,"type":"number"},"tenantArticleRef":{"type":"string"}},"required":["quantity","tenantArticleRef"],"type":"object","title":"ArticleItem","description":"ArticleItem"},"CustomServiceDefinition":{"properties":{"additionalInformation":{"description":"Additional information necessary to fulfil the custom service","items":{"properties":{"additionalInformationRef":{"description":"A reference to the specific additional information of the custom service","type":"string"},"tenantAdditionalInformationId":{"description":"The id of the tenant specific additional information","type":"string"},"value":{"anyOf":[{"type":"string"},{"type":"integer"},{"type":"number"},{"type":"boolean"}],"description":"The value of the additional information"}},"required":["additionalInformationRef"],"type":"object"},"type":"array"},"customAttributes":{"description":"Attributes that can be added to the consumer. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"customServiceRef":{"description":"A reference to the custom service to be applied to the orderline items","type":"string"},"isBundled":{"description":"if true all articles below this service are intrpreted as a bundle","type":"boolean"},"tenantCustomServiceId":{"description":"The id of the tenant specific custom service","type":"string"}},"type":"object","title":"CustomServiceDefinition","description":"CustomServiceDefinition"},"CustomServiceItemForCreation":{"additionalProperties":false,"properties":{"articleItems":{"items":{"$ref":"#/components/schemas/ArticleItem"},"type":"array"},"customServiceDefinition":{"$ref":"#/components/schemas/CustomServiceDefinition"},"customServiceItems":{"items":{"$ref":"#/components/schemas/CustomServiceItemForCreation"},"type":"array"}},"required":["customServiceItems","articleItems","customServiceDefinition"],"type":"object","title":"CustomServiceItemForCreation","description":"CustomServiceItemForCreation"},"DeliveryPreferences":{"additionalProperties":false,"properties":{"collect":{"items":{"$ref":"#/components/schemas/CollectDelivery"},"maxItems":1,"type":"array"},"reservationPreferences":{"$ref":"#/components/schemas/DeliveryReservationPreferences"},"shipping":{"$ref":"#/components/schemas/DeliveryPreferencesShipping"},"sourcingOptionRefs":{"description":"Id of the SourcingOptions","items":{"description":"Reference of a SourcingOptions","type":"string"},"type":"array"},"supplyingFacilities":{"description":"@deprecated Use supplyingFacilities under collect","items":{"description":"Reference of a Facility","type":"string"},"type":"array"},"targetTime":{"description":"At which time the result is expected.","format":"date-time","type":"string"}},"type":"object","title":"DeliveryPreferences","description":"DeliveryPreferences"},"CollectDelivery":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"facilityRef":{"description":"Reference to the facility where the consumer expects to collect the items","type":"string"},"paid":{"default":false,"description":"Indicates if the order is already paid.","type":"boolean"},"provisioningTime":{"description":"The point in time by which the order is supposed to be provisioned.","format":"date-time","type":"string"},"supplyingFacilities":{"deprecated":true,"description":"@deprecated Use supplyingFacilitiesConfigurations","items":{"description":"Reference of a Facility.","type":"string"},"type":"array"},"supplyingFacilitiesConfigurations":{"description":"References of facility that could supply contents of the order to another facility with specific configuration of its usage","items":{"$ref":"#/components/schemas/SupplyingFacilityConfiguration"},"type":"array"},"tenantFacilityId":{"description":"Reference to the facility where the consumer expects to collect the items.","type":"string"}},"type":"object","title":"CollectDelivery","description":"CollectDelivery"},"SupplyingFacilityConfiguration":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"deliveryEvents":{"items":{"$ref":"#/components/schemas/DeliveryEvent"},"type":"array"},"facilityRef":{"description":"ID of the facility.","type":"string"},"tenantFacilityId":{"description":"Reference to the facility.","type":"string"}},"required":["deliveryEvents"],"title":"SupplyingFacilityConfiguration","description":"SupplyingFacilityConfiguration"},"DeliveryEvent":{"properties":{"deliveryTarget":{"$ref":"#/components/schemas/DeliveryTarget"},"deliveryTrigger":{"enum":["DEFAULT"],"type":"string"}},"required":["deliveryTarget","deliveryTrigger"],"title":"DeliveryEvent","description":"DeliveryEvent"},"DeliveryTarget":{"description":"The destination for a delivery","enum":["SHIP_TO_STORE","SHIP_TO_CUSTOMER"],"type":"string","title":"DeliveryTarget"},"DeliveryReservationPreferences":{"properties":{"mode":{"$ref":"#/components/schemas/DeliveryReservationMode"},"reservationTime":{"format":"date-time","type":"string"}},"required":["mode"],"type":"object","title":"DeliveryReservationPreferences","description":"DeliveryReservationPreferences"},"DeliveryReservationMode":{"enum":["SCHEDULED","ASAP","ALAP"],"title":"DeliveryReservationMode","description":"DeliveryReservationMode"},"DeliveryPreferencesShipping":{"properties":{"carrierProductCategory":{"$ref":"#/components/schemas/CarrierProductCategory"},"desiredDeliveryTime":{"format":"date-time","type":"string"},"preferredCarriers":{"items":{"$ref":"#/components/schemas/PreferredCarrier"},"type":"array"},"preferredCarriersWithProduct":{"items":{"$ref":"#/components/schemas/PreferredCarrierWithProduct"},"type":"array"},"preselectedFacilities":{"items":{"$ref":"#/components/schemas/PreselectedFacility"},"type":"array"},"serviceLevel":{"description":"DELIVERY: The parcel will reach the recipient according to the cycle time of the carrier, typically 1-3 days when shipping nationaly. SAMEDAY: The parcel will reach the recipient the same day when ordering.","enum":["DELIVERY","SAMEDAY"],"type":"string"}},"type":"object","title":"DeliveryPreferencesShipping","description":"DeliveryPreferencesShipping"},"CarrierProductCategory":{"description":"Desired product class to choose when ordering a label, this is not a carrier specific value","enum":["STANDARD","EXPRESS","VALUE","FORWARDING"],"type":"string","title":"CarrierProductCategory"},"PreferredCarrier":{"description":"Keys of the preferred carriers to handle out the order","type":"string","title":"PreferredCarrier"},"PreferredCarrierWithProduct":{"additionalProperties":false,"properties":{"carrierKey":{"type":"string"},"carrierProduct":{"type":"string"},"carrierServices":{"items":{"$ref":"#/components/schemas/CarrierServices"},"type":"array"}},"required":["carrierKey"],"title":"PreferredCarrierWithProduct","description":"PreferredCarrierWithProduct"},"CarrierServices":{"description":"Services which should be booked from carrier","enum":["SIGNATURE","CUSTOMER_SIGNATURE","ADULT_SIGNATURE","SATURDAY_DELIVERY","IDENTITY_CHECK_COMPANY","IDENTITY_CHECK_PRIVATE","ADDITIONAL_TRANSPORTATION_INSURANCE"],"type":"string","title":"CarrierServices"},"PreselectedFacility":{"anyOf":[{"required":["facilityRef"]},{"required":["tenantFacilityId"]}],"properties":{"facilityRef":{"description":"Reference to the facility which is supposed to fulfill the order.","type":"string"},"tenantFacilityId":{"description":"Reference to the facility which is supposed to fulfill the order.","type":"string"}},"type":"object","title":"PreselectedFacility","description":"PreselectedFacility"},"OrderLineItemForCreation":{"additionalProperties":false,"properties":{"allowedSubstitutes":{"description":"Array of allowed substitutes for given orderLineItem. If an empty array is provided, no substitute is allowed for this orderLineItem. If allowedSubstitutes is not provided, this configured substitutes on listing level will be available","items":{"$ref":"#/components/schemas/Substitute"},"type":"array"},"article":{"$ref":"#/components/schemas/OrderLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to the orderline. These attributes cannot be used within fulfillment processes, but it could be useful to have the informations carried here.","type":"object"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"measurementValidation":{"$ref":"#/components/schemas/MeasurementValidation"},"quantity":{"description":"quantity of the specific article that has been ordered","format":"int64","minimum":1,"type":"integer"},"scannableCodes":{"items":{"description":"Codes, that identify the article","type":"string"},"type":"array"},"secondaryMeasurementUnitKey":{"description":"Secondary identifier for items unit of measurement.","type":"string"},"secondaryQuantity":{"description":"Secondary quantity of the specific article that has been ordered","format":"int64","minimum":0,"type":"integer"},"shopPrice":{"description":"@deprecated price per piece of this line item Use attributes instead (see: <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">customization by attributes</a>)\n","type":"number"},"tags":{"items":{"$ref":"#/components/schemas/TagReference"},"type":"array"}},"required":["article","quantity"],"type":"object","title":"OrderLineItemForCreation","description":"OrderLineItemForCreation"},"Substitute":{"properties":{"attributes":{"items":{"$ref":"#/components/schemas/SubstituteAttributeItem"},"maxItems":40,"type":"array"},"imageUrl":{"type":"string"},"measurementUnitKey":{"description":"Identifier for items unit of measurement.","type":"string"},"measurementValidation":{"$ref":"#/components/schemas/MeasurementValidation"},"priority":{"description":"This field allows you to rank substitutes against each other. The lowest number is the most preferrable substitute.","minimum":0,"type":"number"},"scannableCodes":{"items":{"description":"Strings, that identify the substitute article","type":"string"},"type":"array"},"secondaryMeasurementUnitKey":{"description":"Identifier for items unit of measurement. E.g. measurementUnitKey is pieces and secondaryQuantity is gram","type":"string"},"tenantArticleId":{"type":"string"},"title":{"type":"string"}},"required":["title","tenantArticleId"],"type":"object","xml":{"name":"Substitute"},"title":"Substitute","description":"Substitute"},"SubstituteAttributeItem":{"allOf":[{"$ref":"#/components/schemas/ArticleAttributeItem"}],"title":"SubstituteAttributeItem","description":"SubstituteAttributeItem"},"MeasurementValidation":{"properties":{"overPickHardTolerancePercentage":{"description":"Allowed hard over pick deviation tolerance.","minimum":0,"type":"number"},"overPickSoftTolerancePercentage":{"description":"Allowed soft over pick deviation tolerance.","minimum":0,"type":"number"},"shortPickHardTolerancePercentage":{"description":"Allowed hard short pick deviation tolerance.","maximum":100,"minimum":0,"type":"number"},"shortPickSoftTolerancePercentage":{"description":"Allowed soft short pick deviation tolerance.","maximum":100,"minimum":0,"type":"number"}},"title":"MeasurementValidation","description":"MeasurementValidation"},"OrderLineItemArticle":{"allOf":[{"$ref":"#/components/schemas/AbstractArticle"},{"properties":{"attributes":{"description":"Attributes are used in the fulfillmenttools platform in order to impose a certain degree of customization to a process, such as improving the appearance in the platform and clients.\nDetails about usage can be found <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/customization-via-attributes\">here</a>","items":{"$ref":"#/components/schemas/OrderArticleAttributeItem"},"type":"array"},"customAttributes":{"deprecated":true,"description":"@deprecated Please use customAttributes in OrderLineItem.\n","nullable":true,"type":"object"}},"type":"object"}],"xml":{"name":"OrderLineItemArticle"},"title":"OrderLineItemArticle","description":"OrderLineItemArticle"},"AbstractArticle":{"properties":{"titleLocalized":{"allOf":[{"$ref":"#/components/schemas/LocaleString"}],"description":"The translations for the title of the product"},"customAttributes":{"descrip
[...]
